da6b81fa98649b0004eb8125298bab6d3ffb6b45
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
43 typeset dvdname=""
44 typeset debug=""
45 typeset dest=""
46 typeset isofile=""
47 typeset vobfile=""
48 typeset dvdpath=""
49 typeset aspect=""
50 typeset SCALE=""
51 typeset CROP=""
52 typeset profile="xvidvhq"
53 typeset extension=""
54 typeset -i force_onepass_mode=0
55 typeset -i eject_disk=1
56 typeset -i keep_isofile=0
57 typeset -i keep_vobfile=0
58 typeset -i keep_dvdfolder=0
59 typeset -i keep_intermediate_files=0
60 typeset -i make_final_dest_vob=0
61 typeset -i make_final_dest_iso=0
62 typeset -i make_final_dest_folder=0
63 typeset -i make_final_dest_comp=0
64 typeset -i errors=0
65 typeset -i show_usage=0
66 typeset -i mirror_mode=0
67 typeset -i target_bitrate=2000
68 typeset -i target_size=0
69 typeset -i audio_2ch=0
70 typeset -i invalid_feature_title=0
71 typeset -i feature_title_override=0
72 typeset -i mplayer_dumpstream_incompatibility=0
73
74 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
75 do
76     case $opt in
77         (n)     dvdname=$OPTARG;;
78         (d)     dest=$OPTARG;;
79         (b)     target_bitrate=$OPTARG;;
80         (s)     target_size=$OPTARG;;
81         (2)     audio_2ch=1;;
82         (1)     force_onepass_mode=1;;
83         (v)     make_final_dest_vob=1;;
84         (i)     make_final_dest_iso=1;;
85         (f)     make_final_dest_folder=1;; 
86         (x)     make_final_dest_comp=1;;
87         (m)     mirror_mode=1;;
88         (k)     keep_intermediate_files=1;;
89         (t)     feature_title_override=$OPTARG;;
90         (a)     aspect=$OPTARG;;
91         (p)     profile=$OPTARG;;
92         (e)     extension=$OPTARG;;
93         (j)     eject_disk=$OPTARG;;
94         (w)     set -$opt;;
95         (h)     show_usage=1;;
96         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
97         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
98     esac
99 done
100
101 shift $((OPTIND-1))
102
103 function usage() {
104     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
105     echo >&2 "Revision $REV"
106     echo >&2 "Options:"
107     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
108     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
109     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
110     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
111     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
112     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
113     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
114     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
115     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
116     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
117     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
118     echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
119     echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
120     echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
121     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
122     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
123     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
124     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
125     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
126     echo >&2 "                 The default operation is non-mirror mode where only the main"
127     echo >&2 "                 feature title will be ripped."
128     echo >&2 "   -v            Make the final image a DVD VOB file"
129     echo >&2 "   -i            Make the final image a DVD ISO file"
130     echo >&2 "   -f            Make the final image a DVD folder"
131     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
132     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
133     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
134     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
135     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
136     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
137     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
138     echo >&2 "   -j <n>        Eject the disk:"
139     echo >&2 "                 - 0 = do not eject the disk"
140     echo >&2 "                 - 1 = eject after the entire script is done (default)"
141     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
142     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
143     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
144     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
145     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
146     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
147     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
148     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
149     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
150     echo >&2 ""
151     exit 2
152 }
153
154 if (($errors)) || (($show_usage))
155 then
156   usage
157 fi
158
159 # Sanity Check - Command Line Options 
160 if [ "$dest" == "" ]; then
161   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
162   usage
163 fi
164
165 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
166   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
167   usage
168 fi
169
170 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
171   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
172   usage
173 fi
174
175 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
176    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
177   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
178   usage
179 fi
180
181 if [ $mirror_mode -eq 1 ]; then
182   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
183      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
184     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
185     usage
186   fi
187 fi
188
189 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
190 if [ "$aspect" != "" ]; then
191   echo "$aspect" | grep -q "x"
192   if [ $? == 0 ]; then
193     echo "-E- You must specify the aspect option with a value whose format is W:H"
194     exit 1
195   fi
196   echo "$aspect" | grep -q ":"
197   if [ $? != 0 ]; then
198     SCALE=",scale -zoom -sws 9 -xy $aspect"
199   else
200     SCALE=",scale=$aspect"
201   fi
202 fi
203
204
205 # Sanity Check - Key executables
206 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
207 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
208 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
209 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
210 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
211 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
212 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
213 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
214
215 ##############################################################################################
216
217 typeset -i ripdvd
218 if [ -z "$dvdname" ]; then
219   # make sure the DVD device is accessible
220   volname $dev > /dev/null 2>&1
221   if [ $? != 0 ]; then
222     echo "-E- Can't access the DVD device $dev"
223     exit 1
224   fi
225   # now capture the volume name from the device
226   dvdname=`volname $dev | awk '{ print $1 }'`
227   ripdvd=1
228 else 
229   # check to see if dvdname is a full path to a real directory
230   # if it is, set dvdname and dvdpath appropriately
231   if [ -d "$dvdname" ]; then
232     dvdpath="$dvdname"
233     dvdname=`basename "$dvdname"`
234     keep_dvdfolder=1
235     if [ -z "$dvdname" ]; then
236      echo "-E- Unable to extract dvdname from path: $dvdpath"
237      exit 1
238     fi
239     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
240       echo "-E- You must supply a full path to a valid DVD folder with this option"
241       exit 1
242     fi
243   fi
244
245   # Check to see if dvdname is a full path to a file
246   if [ -f "$dvdname" ]; then
247     valid_file=0
248
249     # check to see if dvdname is a full path to an MPG2 (VOB) file
250     # if it is, set dvdname and vobfile appropriately
251     file "$dvdname" | grep -q "MPEG"
252     if [ $? == 0 ]; then
253       # It is a valid MPEG2 file, now strip the extension off our dvdname
254       vobfile="$dvdname"
255       dvdname=`basename "$dvdname"`
256       dvdname=${dvdname%.[^.]*}
257       keep_vobfile=1
258       valid_file=1
259     fi
260
261     # check to see if dvdname is a full path to an ISO file
262     # if it is, set dvdname and isofile appropriately
263     file "$dvdname" | grep -q -e "ISO" -e "UDF"
264     if [ $? == 0 ]; then
265       # It is a valid ISO file, now strip the extension off our dvdname
266       isofile="$dvdname"
267       dvdname=`basename "$dvdname"`
268       dvdname=${dvdname%.[^.]*}
269       keep_isofile=1
270       valid_file=1
271     fi    
272
273     # If we didn't find a handler for the file above, complain
274     if [ $valid_file -eq 0 ]; then
275       echo "-E- Unsupported file type: $vobfile"
276       exit 1
277     fi
278   fi
279   ripdvd=0
280   # Since we aren't ripping a DVD disk, don't eject anything
281   eject_disk=0
282 fi
283
284 # remove bad characters from the dvdname
285 dvdname=${dvdname%.} # remove trailing '.' character
286
287 # add the suffix extension to the end of the dvdname
288 dvdname=$dvdname$extension
289
290 # make a "safe" dvdname (remove special characters)
291 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
292
293 # Make sure we have a non-empty dvdname
294 if [ -z "$dvdname" ]; then
295   echo "-E- unable to determine dvdname"
296   exit 1
297 fi
298
299 # make sure our vobfile value is set
300 if [ -z "$vobfile" ]; then
301   vobfile="$dest/$dvdname.VOB"
302 fi
303
304 # set up some variables to hold various logfiles
305 logfile="$logdir/$dvdname.log"
306 passlogfile="$tmpdir/$safedvdname.log"
307 ddrescuelog=`tempfile`
308 dvdauthorlog=`tempfile`
309 encodelog=`tempfile`
310 dumplog=`tempfile`
311
312 # create the tmpdir if it doesn't already exist
313 if [ ! -d "$tmpdir" ]; then
314   mkdir -p "$tmpdir"
315   if [ $? != 0 ]; then
316     echo "-E- Unable to create the tmpdir: $tmpdir"
317     exit 1
318   fi
319 fi
320
321 # create the logdir if it doesn't already exist
322 if [ ! -d "$logdir" ]; then
323   mkdir -p "$logdir"
324   if [ $? != 0 ]; then
325     echo "-E- Unable to create the logdir: $logdir"
326     exit 1
327   fi
328 fi
329
330 ##############################################################################################
331 # cleanup functions
332 ##############################################################################################
333 cleanup() { 
334   if [ $keep_intermediate_files -eq 0 ]; then
335     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
336     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
337     [[ -e "$encodelog" ]] && rm -f "$encodelog"
338     [[ -e "$dumplog" ]] && rm -f "$dumplog"
339   else
340     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
341     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
342     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
343     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
344   fi
345   echo ""
346 }
347
348 fatal_and_exit() {
349   if [[ -z "$1" ]]; then
350     msg="-E- control-c killed us"
351   else
352     msg=$1
353   fi
354   echo -e 2>&1 "$msg" | tee -a "$logfile"
355   if [[ -n "$mailto" ]]; then
356     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
357   fi
358   keep_intermediate_files=1
359   exit 1
360 }
361
362 # Call our cleanup functions on INT and EXIT signals
363 trap fatal_and_exit INT
364 trap cleanup EXIT
365
366 ##############################################################################################
367 # processing functions
368 ##############################################################################################
369
370 # encode the vob file into a compressed file format
371 function encode_vob_file {
372
373   # Set a variable that we will use later to determine if we found a handler for $profile or not
374   typeset -i found_profile=0
375
376   # For a given profile, to override the 2 pass behavior to be single pass,
377   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
378   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
379   PASSES="1 2"
380
381   # Declare our default 2 pass variables
382   passlogfile_opt="-passlogfile $passlogfile"
383   pass_opt="pass=%PASS"
384
385   # Check the force_onepass_mode. If it is set, change our variables appropriately
386   # to force 1-pass encoding across all profiles.
387   if [ $force_onepass_mode -eq 1 ]; then
388     PASSES="2"
389     passlogfile_opt=""
390     pass_opt=""    
391   fi
392
393   # XVID profile
394   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
395     found_profile=1
396     final_output_file="$dest/$dvdname.avi"
397     mencoder_general_opts="-quiet $lang_opts $passlogfile_opt"
398     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
399     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
400     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
401
402     # Very High Quality (16fps)
403     if [ "$profile" == "xvidvhq" ]; then
404       video_encoder_opts[0]="bitrate=$target_bitrate"
405       video_encoder_opts[1]="threads=$mencoder_threads"
406       video_encoder_opts[2]="chroma_opt"
407       video_encoder_opts[3]="vhq=4"
408       video_encoder_opts[4]="bvhq=1"
409       video_encoder_opts[5]="quant_type=mpeg"
410       video_encoder_opts[6]="autoaspect"
411     fi
412     # High Quality (20fps)
413     if [ "$profile" == "xvidhq" ]; then
414       video_encoder_opts[0]="bitrate=$target_bitrate"
415       video_encoder_opts[1]="threads=$mencoder_threads"
416       video_encoder_opts[2]="chroma_opt"
417       video_encoder_opts[3]="vhq=2"
418       video_encoder_opts[4]="bvhq=1"
419       video_encoder_opts[5]="quant_type=mpeg"
420       video_encoder_opts[6]="autoaspect"
421     fi
422     # Fast (28fps)
423     if [ "$profile" == "xvid" ]; then
424       video_encoder_opts[0]="bitrate=$target_bitrate"
425       video_encoder_opts[1]="threads=$mencoder_threads"
426       video_encoder_opts[2]="vhq=0"
427       video_encoder_opts[3]="turbo"
428       video_encoder_opts[4]="autoaspect"
429     fi
430
431     for OPTS in "${video_encoder_opts[@]}"; do 
432       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
433     done
434
435     if [ $audio_2ch -eq 0 ]; then
436       # These options produce good 6 channel audio for linux and windows
437       mencoder_audio_opts="-oac copy"
438       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
439       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
440       mencoder_audioch_opts[1]="-af channels=6"
441       mencoder_audioch_opts[2]=""
442     else
443       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
444       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
445       mencoder_audioch_opts[0]=""
446     fi
447  
448   fi
449
450   # MP4 encoding profiles
451   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
452     found_profile=1
453     final_output_file="$dest/$dvdname.mp4"
454     mencoder_general_opts="-quiet $lang_opts $passlogfile_opt"
455     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
456     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
457     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
458
459     # Very High Quality (6fps)
460     if [ "$profile" == "mp4vhq" ]; then
461       video_encoder_opts[0]="bitrate=$target_bitrate"
462       video_encoder_opts[1]="threads=$mencoder_threads"
463       video_encoder_opts[2]="subq=6"
464       video_encoder_opts[3]="frameref=5"
465       video_encoder_opts[4]="bframes=3"
466       video_encoder_opts[5]="8x8dct"
467       video_encoder_opts[6]="me=umh"
468       video_encoder_opts[7]="b_pyramid"
469       video_encoder_opts[8]="weight_b"
470       video_encoder_opts[9]="partitions=all" 
471     fi
472     # High Quality (13fps)
473     if [ "$profile" == "mp4hq" ]; then
474       video_encoder_opts[0]="bitrate=$target_bitrate"
475       video_encoder_opts[1]="threads=$mencoder_threads"
476       video_encoder_opts[2]="subq=5"
477       video_encoder_opts[3]="frameref=2"
478       video_encoder_opts[4]="bframes=3"
479       video_encoder_opts[5]="8x8dct"
480       video_encoder_opts[6]="b_pyramid"
481       video_encoder_opts[7]="weight_b"
482     fi
483     # Fast (17fps)
484     if [ "$profile" == "mp4" ]; then
485       video_encoder_opts[0]="bitrate=$target_bitrate"
486       video_encoder_opts[1]="threads=$mencoder_threads"
487       video_encoder_opts[2]="subq=4"
488       video_encoder_opts[3]="bframes=2"
489       video_encoder_opts[4]="b_pyramid"
490       video_encoder_opts[5]="weight_b"
491     fi
492
493     for OPTS in "${video_encoder_opts[@]}"; do
494       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
495     done
496
497     if [ $audio_2ch -eq 0 ]; then
498       # These options produce good 6 channel audio for linux and windows
499       #mencoder_audio_opts="-oac copy"
500       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
501       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
502       #mencoder_audioch_opts[1]="-af channels=6"
503       #mencoder_audioch_opts[2]=""
504       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
505       mencoder_audioch_opts[0]="-channels 6 -srate 48000"
506     else
507       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
508       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
509       #mencoder_audioch_opts[0]=""
510       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
511       mencoder_audioch_opts[0]="-channels 2 -srate 48000"
512     fi
513
514   fi
515
516   # iphone and ipod MP4 profiles
517   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
518     found_profile=1
519     if [ "$profile" == "iphone" ]; then
520       # SCALE: 480x320
521       # scale width to 480, set height appropriately, but keep a multiple of 16
522       #SCALE=",scale=480:-10"
523       # scale the video down however far is necessary to fit in 480x320
524       SCALE=",dsize=480:320:0,scale=-8:-8"
525     else
526       # SCALE: 320x240
527       # scale width to 320, set height appropriately, but keep a multiple of 16
528       #SCALE=",scale=320:-10"
529       # scale the video down however far is necessary to fit in 320x240
530       SCALE=",dsize=320:240:0,scale=-8:-8"
531     fi
532     final_output_file="$dest/$dvdname.mp4"
533     mencoder_general_opts="-quiet $lang_opts $passlogfile_opt"
534     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
535     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
536     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
537     video_encoder_opts[0]="bitrate=$target_bitrate"
538     video_encoder_opts[1]="threads=$mencoder_threads"
539     video_encoder_opts[2]="vbv_maxrate=1500"
540     video_encoder_opts[3]="vbv_bufsize=2000"
541     video_encoder_opts[4]="nocabac"
542     video_encoder_opts[5]="me=umh"
543     video_encoder_opts[6]="subq=6"
544     video_encoder_opts[7]="frameref=6"
545     video_encoder_opts[8]="trellis=1"
546     video_encoder_opts[9]="level_idc=30"
547     video_encoder_opts[10]="global_header"
548     video_encoder_opts[11]="bframes=0"
549     video_encoder_opts[12]="partitions=all"
550     for OPTS in "${video_encoder_opts[@]}"; do 
551       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
552     done
553
554     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
555     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
556   fi
557
558   if [ $found_profile -eq 0 ]; then
559     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
560   fi
561
562   # Do not edit this line. $mencoder_video_encoder_opts must be last
563   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
564   mencoder_retval=0
565
566   for PASS in $PASSES
567   do 
568     # Set some options based on which pass we are in
569     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
570     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
571     [ $PASS -eq 1 ] && output_file="/dev/null"
572     [ $PASS -eq 2 ] && output_file="$final_output_file"
573   
574     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
575     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
576     do
577       echo -e "   Encoding pass $PASS"
578       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
579       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
580       mencoder_retval=$? 
581       grep -q "\[channels\] Invalid" $encodelog
582       if [ $? != 0 ]; then          
583         break;
584       else
585         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
586       fi
587     done
588       
589     if [ $mencoder_retval != 0 ]; then
590       fatal_and_exit "-E- Unhandled mencoder error"
591     fi
592
593     # Concatenate the encode log to our main log file, greping out unwanted lines
594     cat $encodelog | grep -v "Pos:" >> "$logfile"
595
596   done
597 }
598
599 function make_dvd_iso_image {
600
601   isofile="$1"
602
603   # check to see if we have a dvdpath to rip from instead of $dev
604   if [ -z "$dvdpath" ]; then
605     # load the CSS codes in the DVD drive 
606     lsdvd $dev >> "$logfile"
607     if [ $? != 0 ]; then
608       fatal_and_exit "-E- lsdvd $dev failed" 
609     fi
610
611     # read the DVD, ignoring/skipping CRC errors
612     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
613     if [ $? != 0 ]; then
614       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
615     fi
616     cat "$ddrescuelog" >> "$logfile"
617   else
618     # rip from a path instead
619     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
620   fi
621 }
622
623 function make_dvd_iso_image_from_folder {
624   
625   src="$1"
626   dst="$2"
627   handle_error=$3
628   
629   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
630
631   # make an iso image out of our directory
632   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
633   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
634
635   # set the audio languages from the iso if it exists and is non-zero in size
636   if [ -s "$dst" ]; then
637     get_feature_title "$dst"
638     get_audio_id_from_iso "$dst"
639   fi
640
641   # make sure we were able to create the iso image from the folder given to us
642   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
643     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
644     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
645     # remove the bad iso file
646     [[ -e "$dst" ]] && rm -f "$dst"
647     # get the feature title from the DVD folder
648     get_feature_title "$dvdpath"
649     # create our main VOB file from the ISO
650     create_main_vob_with_mplayer "$dvdpath" 
651     # get our audio id from the VOB file
652     get_audio_id_from_vob "$vobfile"
653   fi
654 }
655
656 function make_dvdbackup_folder_image {
657   # extract the feature title from the DVD image
658   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
659   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
660   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
661   if [ $? != 0 ]; then
662     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
663   fi
664 }
665
666 function make_dvdauthor_folder_image {
667   # create a new DVD video of the feature title
668   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
669   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
670   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
671   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
672
673   # There is a chance that dvdauthor won't like some of the VOBs.
674   # We can't tell ahead of time which ones it will choke on. 
675   # So, we need to run it over and over again until it can process
676   # all the VOBs. If it can't handle one of them, run it through
677   # mencoder to fix it and try again. These errors are typically
678   # present due to the copy protection that ddrescue removed.
679   grep -q "SCR moves" $dvdauthorlog
680   while [ $? == 0 ]; do
681     # fix bad vobs that get the "SCR moves backwards" error:
682     #  STAT: Processing VTS_01_0.VOB...
683     #  ERR:  SCR moves backwards, remultiplex input.
684     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
685     if [[ ! -f "$badvob" ]]; then
686       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
687     fi
688     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
689     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
690     mv -f $badvob.fixed $badvob
691     echo "-> Creating DVD video $dest/$dvdname"
692     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
693     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
694     grep -q "SCR moves" $dvdauthorlog
695   done
696 }
697
698 function get_feature_title {
699   source="$1"
700   # if a feature title was given on the command line, use it
701   if [ $feature_title_override -ne 0 ]; then
702     feature_title=$feature_title_override
703     return 0
704   fi
705   # otherwise, use lsdvd to figure it out
706   if [ $ripdvd -eq 1 ]; then
707     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
708   else 
709     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
710   fi
711 }
712
713 function create_main_vob_with_cat {
714   # cd to the feature title DVD folder
715   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
716   if [ $? != 0 ]; then
717     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
718   fi
719
720   # concatenate all the VOBs together into 1 giant VOB
721   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
722   cat $vobs > "$tmpdir/$dvdname.VOB"
723
724   # cd back to the dir we started from
725   popd > /dev/null 2>&1
726 }
727
728 function create_main_vob_with_mplayer {
729
730   # argument processing  
731   source="$1"
732   remove_dumplog=$2
733
734   # make sure we have a valid feature title
735   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
736     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
737   fi
738
739   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
740   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
741     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
742     msg="$msg We also detected another condition that requires us to use dumpstream. "
743     msg="$msg\n    Unable to rip this DVD in the mode you requested."
744     fatal_and_exit "$msg"
745   fi
746
747   # use mplayer to create the main VOB file
748   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
749   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
750   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
751   if [ $? != 0 ]; then
752     cat $dumplog | grep -v "^A:" >> "$logfile"
753     fatal_and_exit "-E- Mplayer Failed"
754   fi
755   cat $dumplog | grep -v "^A:" >> "$logfile"
756   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
757 }
758
759 function get_audio_id_from_iso {
760   # Adjust our audio ID to find the english audio stream
761   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
762   iso="$1"
763   aidcheck=`tempfile`
764   aid=128
765   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
766   grep -q "aid: $aid" $aidcheck
767   while [ $? == 1 ] && [ $aid -lt 159 ]; do
768     (( aid = aid + 1 ))
769     grep -q "aid: $aid" $aidcheck
770   done
771   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
772   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
773   # mencoder default DVD audio track language selection (english)
774   lang_opts="-aid $aid -alang en"
775 }
776
777 function get_crop_from_iso { 
778   FRAMES=10000
779   echo "-> Detecting black frame border crop value from ISO file"
780   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
781   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
782   [[ -e "md5sums" ]] && rm -f "md5sums"
783   CROP=`cat $dumplog | grep CROP | tail -1`
784   echo "   Found crop value of $CROP" >> "$logfile"
785   CROP=${CROP#* crop=}
786   CROP=${CROP%%\).*}
787   typeset -i CROPCHECK
788   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
789   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
790   if [ -z "$CROP" ]; then
791     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
792     return
793   fi
794   if [ $CROPCHECK -lt 0 ]; then 
795     CROP=""
796   else 
797     CROP=",crop=$CROP"
798   fi
799   echo "   Setting mencoder crop filter to: $CROP"
800 }
801
802 function get_crop_from_vob { 
803   FRAMES=10000
804   echo "-> Detecting black frame border crop value from VOB file"
805   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
806   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
807   [[ -e "md5sums" ]] && rm -f "md5sums"
808   CROP=`cat $dumplog | grep CROP | tail -1`
809   echo "   Found crop value of $CROP" >> "$logfile"
810   CROP=${CROP#* crop=}
811   CROP=${CROP%%\).*}
812   typeset -i CROPCHECK
813   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
814   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
815   if [ -z "$CROP" ]; then
816     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
817     return
818   fi
819   if [ $CROPCHECK -lt 0 ]; then 
820     CROP=""
821   else 
822     CROP=",crop=$CROP"
823   fi
824   echo "   Setting mencoder crop filter to: $CROP"
825 }
826
827 function get_audio_id_from_vob {
828   # Adjust our audio ID to find the english audio stream
829   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
830   vob="$1"
831   aidcheck=`tempfile`
832   aid=128
833   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
834   grep -q "Found audio stream: $aid" $aidcheck
835   while [ $? == 1 ] && [ $aid -lt 159 ]; do
836     (( aid = aid + 1 ))
837     grep -q "Found audio stream: $aid" $aidcheck
838   done
839   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
840   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
841   # mencoder default DVD audio track language selection (english)
842   lang_opts="-aid $aid -alang en"
843 }
844
845 function check_vob_for_corrupted_start {
846   # check to see if the beginning of the DVD has a form of copy protection
847   # where they have deliberately broken the first X number of frames of the DVD.
848   # If we don't skip these, our resulting VOB file will not play.
849   badvobcheck=`tempfile`
850   endpos=360
851   skip=0
852   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
853   if [ $? != 0 ]; then
854     fatal_and_exit "-E- Mencoder Failed"
855   fi
856   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
857   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
858     (( skip = skip + 5 ))
859     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
860     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
861     if [ $? != 0 ]; then
862       fatal_and_exit "-E- Mencoder Failed"
863     fi
864     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
865   done
866   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
867
868   # cat the giant VOB into mencoder to create a playable VOB file
869   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
870   if [ $? != 0 ]; then
871     fatal_and_exit "-E- Mencoder Failed"
872   fi
873 }
874
875 function check_vob_for_completeness {
876   # check to make sure we got out a complete VOB.
877   # there is another kind of copy protection where the VOB's may
878   # have "MPG EOF" frames in the middle of the stream. 
879   # this causes mencoder to not process the entire VOB, and exit without any errors.
880   # detect this by seeing how much smaller the dst vob is from the src vob.
881   MAX_FILESIZE_DELTA_PERCENT=70
882   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
883   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
884   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
885   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
886     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
887     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
888     create_main_vob_with_mplayer "$isofile"
889     [[ -e "$dumplog" ]] && rm -f $dumplog
890     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
891     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
892     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
893       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
894     fi
895   fi
896 }
897
898 function check_vob_for_too_many_video_packets {
899   # If our earlier algorithm to work around this failed, throw an error.
900   # check to see if this DVD has a protection scheme we don't know how to work around
901   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
902   # for some reason, the video is black, while the audio rolls, then the video finally comes
903   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
904   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
905   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
906   grep -q "Too many video packets in the buffer:" "$logfile"
907   if [ $? == 0 ]; then
908     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
909     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
910     create_main_vob_with_mplayer "$isofile"
911     grep -q "Too many video packets in the buffer:" $dumplog
912     if [ $? == 0 ]; then
913       [[ -e "$dumplog" ]] && rm -f $dumplog
914       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
915     fi
916     [[ -e "$dumplog" ]] && rm -f $dumplog
917   fi
918 }
919
920 function check_vob_for_a52_crc_errors {
921   # Let's see if we can playback our newly created VOB file without any errors.
922   # if there are issues, let's detect them now, and try to recreate the VOB
923   # there are some forms of copy protection that have missed above, that evidence
924   # themselves when we try to playback the VOB file. This was added to deal with
925   # the "a52: CRC check failed" copy protection scheme.
926   MAX_ERRORS=10
927   ENDPOS=120
928   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
929   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
930   cat $dumplog | grep -v "^A:" >> "$logfile"
931   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
932   if [ $errors -gt $MAX_ERRORS ]; then
933     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
934     create_main_vob_with_mplayer "$isofile"
935     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
936     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
937     if [ $? != 0 ]; then
938       cat $dumplog | grep -v "^A:" >> "$logfile"
939       fatal_and_exit "-E- Mplayer Failed"
940     fi
941     cat $dumplog | grep -v "^A:" >> "$logfile"
942     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
943     if [ $errors -gt $MAX_ERRORS ]; then
944       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
945     fi
946   fi
947   [[ -e "$dumplog" ]] && rm -f $dumplog
948 }
949
950 function calculate_bitrate_from_target_size {
951   # determine what our bitrate needs to be if a target size was specified instead
952   if [ $target_size -ne 0 ]; then
953     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
954     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
955     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
956   fi
957 }
958
959 function create_dvdauthor_dvd_xml_file {
960   # make a dvdauthor xml menu file to create a valid DVD video from 
961   # this script does a good job, but we'll still need to clean it up a bit after it runs
962   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
963   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
964   if [ $? != 0 ]; then
965     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
966   fi
967
968   # replace the first line of the xml file to remove the bad dest path
969   awk -v line=1 -v new_content="<dvdauthor>" '{
970     if (NR == line) {
971       print new_content;
972     } else {
973       print $0;
974     }
975   }' dvd.xml > dvd.xml.new
976   mv -f dvd.xml.new dvd.xml
977   if [ $? != 0 ]; then
978     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
979   fi
980
981   # remove the "<video " property line from the xml file
982   cat dvd.xml | grep -v "<video" > dvd.xml.new
983   mv -f dvd.xml.new dvd.xml
984   if [ $? != 0 ]; then
985     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
986   fi
987   
988   # remove the extra <pgc>..</pgc> pairs
989   cat dvd.xml | awk 'BEGIN {x=1}
990   {
991     if ($0~"</pgc>") {x=0}
992     if (x==1) {print $0}
993     if ($0~"<pgc>") {x=1}
994   }' > dvd.xml.new
995   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
996   mv -f dvd.xml.new dvd.xml
997   if [ $? != 0 ]; then
998     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
999   fi
1000
1001   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1002   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1003   mv -f dvd.xml.new dvd.xml
1004   if [ $? != 0 ]; then
1005     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1006   fi
1007 }
1008
1009 function check_for_mplayer_dumpstream_incompatibility {
1010
1011   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1012
1013   if [ ! -e "$vobfile" ]; then
1014     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1015     # A DVD that has 99 titles, where the longest title isn't the main feature
1016     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1017     # out what the feature title is. This script will run through that flow if we
1018     # set use_mplayer_dumpstream to 0. Check for this here.
1019     if [ $ripdvd -eq 1 ]; then
1020       lsdvd $dev | grep -q "Title: 99"
1021     else
1022       lsdvd "$isofile" | grep -q "Title: 99"
1023     fi
1024     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1025     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1026       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1027         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1028         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1029         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1030         invalid_feature_title=1
1031       else 
1032         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1033         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1034         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1035         use_mplayer_dumpstream=0
1036         invalid_feature_title=1
1037       fi
1038       return
1039     fi
1040   fi
1041
1042   # There is another form of protection that causes the mplayer dumpstream to fail. 
1043   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1044   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1045   # problem before continuing.
1046   if [ -e "$vobfile" ]; then
1047     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1048     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1049     grep -q "Too many audio packets in the buffer" $dumplog
1050     if [ $? == 0 ]; then
1051       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1052       use_mplayer_dumpstream=0
1053       mplayer_dumpstream_incompatibility=1
1054     fi
1055     [[ -e "$dumplog" ]] && rm -f $dumplog
1056   fi
1057 }
1058
1059 function fill_mythvideo_metadata {
1060
1061   # This function must be passed the filename as an argument
1062   # The filename must be a full path to the file
1063   filename="$1"
1064
1065   # Make sure the fill mythvideo metadata option has been set to 1
1066   if [ $fill_mythvideo_metadata -eq 0 ]; then
1067     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1068     return 0
1069   fi
1070
1071   # If the fill mythvideo metadata script is present, run it
1072   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1073   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1074     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1075     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1076   else
1077     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1078     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1079   fi
1080 }
1081
1082 # remove the intermediate VOB file
1083 function remove_intermediate_vob_file {
1084   if [ $keep_intermediate_files -eq 0 ]; then
1085     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1086   else
1087     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1088   fi
1089 }
1090
1091 # remove the original DVD image 
1092 function remove_intermediate_iso_file {
1093   [[ $keep_isofile -eq 1 ]] && return 1
1094   if [ $keep_intermediate_files -eq 0 ]; then
1095     [[ -e "$isofile" ]] && rm "$isofile"
1096   else
1097     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1098   fi
1099 }
1100
1101 # remove the intermediate dvdbackup folder
1102 function remove_intermediate_dvdbackup_folder {
1103   if [ $keep_intermediate_files -eq 0 ]; then
1104     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1105   else
1106     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1107   fi
1108 }
1109
1110 ##############################################################################################
1111 # MAIN
1112 ##############################################################################################
1113
1114 # Make a note of when this DVD rip started
1115 date=`date`
1116 echo -e "\n$date DVD rip started" >> "$logfile"
1117
1118 # Rip the DVD - Mirror Mode
1119 if [ $mirror_mode -eq 1 ]; then
1120   echo "-> Ripping DVD $dvdname to $dest"
1121
1122   # use ddrescue to make an ISO image of the disk
1123   make_dvd_iso_image "$dest/$dvdname.iso"
1124
1125   # add this video data to the mythtv DB
1126   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1127
1128   # eject the disk upon completion
1129   if [ $eject_disk -ne 0 ]; then
1130     eject -T $dev
1131   fi
1132
1133   date=`date`
1134   echo "$date DVD rip completed" | tee -a "$logfile"
1135
1136   if [[ -n "$mailto" ]]; then
1137     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1138   fi
1139
1140 fi
1141
1142 # Rip the DVD - Main Title Feature Only
1143 if [ $mirror_mode -eq 0 ]; then
1144
1145   # Rip image from DVD
1146   if [ $ripdvd -eq 1 ]; then
1147     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1148     # use ddrescue to make an ISO image of the disk
1149     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1150   fi
1151
1152   # Rip image from DVD path
1153   if [ -n "$dvdpath" ]; then
1154     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1155     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1156   fi
1157
1158   # make sure our isofile value is set
1159   if [ -z "$isofile" ]; then
1160     isofile="$tmpdir/$dvdname.iso"
1161   fi
1162      
1163   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1164
1165     if [ ! -e "$vobfile" ]; then
1166       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1167       
1168       # get the feature title from the ISO
1169       get_feature_title "$isofile"
1170  
1171       # get the crop value from the ISO
1172       get_crop_from_iso
1173
1174       # check for mplayer dumpstream incompatibilities
1175       # if they exist, this method will set this mode to 0.
1176       check_for_mplayer_dumpstream_incompatibility
1177
1178       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1179
1180         # get our audio id from the ISO file
1181         get_audio_id_from_iso "$isofile"
1182
1183         # create our main VOB file from the ISO
1184         create_main_vob_with_mplayer "$isofile"
1185      
1186         # remove the intermediate VOB file
1187         remove_intermediate_vob_file
1188
1189         # it's possible that our VOB is still corrupted in some manner
1190         # check to make sure it is still a good VOB before continuing.
1191         check_for_mplayer_dumpstream_incompatibility
1192
1193       fi
1194  
1195       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1196
1197         # use dvdbackup to make a DVD folder of the feature title
1198         make_dvdbackup_folder_image
1199   
1200         # create our main VOB file
1201         create_main_vob_with_cat
1202
1203         # get our audio id from the VOB file
1204         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1205   
1206         # check for corrupted VOB start
1207         check_vob_for_corrupted_start
1208  
1209         # check to make sure our VOB is complete
1210         check_vob_for_completeness
1211
1212         # check to make sure our VOB doesn't have too many video packets
1213         check_vob_for_too_many_video_packets
1214
1215         # check to make sure our VOB doesn't have a52 crc errors
1216         check_vob_for_a52_crc_errors
1217
1218         # remove the intermediate VOB file
1219         remove_intermediate_vob_file
1220
1221       fi
1222
1223       # remove the intermediate ISO file
1224       remove_intermediate_iso_file
1225
1226     else
1227       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1228       # get our audio id from the VOB file
1229       get_audio_id_from_vob "$vobfile"
1230       # get the crop value from the VOB
1231       get_crop_from_vob
1232     fi
1233
1234     # eject the DVD disk since we are finished with it
1235     [ $eject_disk -eq 2 ] && eject -T $dev
1236
1237     # encode the VOB file to a compressed file format
1238     if [ $make_final_dest_comp -eq 1 ]; then
1239       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1240
1241       # determine what our bitrate needs to be if a target size was specified instead
1242       calculate_bitrate_from_target_size        
1243      
1244       # encode the vob file into a compressed file format
1245       encode_vob_file
1246
1247       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1248         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1249         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1250       else
1251         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1252         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1253       fi
1254     fi
1255
1256   # add this video data to the mythtv DB
1257   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1258   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1259     
1260   else
1261
1262   # use dvdbackup to make a DVD folder of the feature title
1263   make_dvdbackup_folder_image
1264
1265   # cd to the feature title DVD folder
1266   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1267   if [ $? != 0 ]; then
1268     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1269   fi
1270   
1271   # create the dvd.xml file for dvdauthor
1272   create_dvdauthor_dvd_xml_file  
1273
1274   # make the final DVD folder image
1275   make_dvdauthor_folder_image
1276
1277   # add this video data to the mythtv DB
1278   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1279  
1280   # cd back to the dir we started from
1281   popd > /dev/null 2>&1
1282
1283   if [ $make_final_dest_iso -eq 1 ]; then
1284
1285     # make an iso image out of our directory
1286     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1287    
1288     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1289     if [ -s "$dest/$dvdname.iso" ]; then
1290       if [ $make_final_dest_folder -eq 0 ]; then
1291         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1292         # remove the folder of the DVD image now that we have a .iso version of it
1293         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1294       fi
1295     else
1296       # we created an empty iso file, remove it
1297       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1298       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1299       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1300     fi
1301  
1302     # add this video data to the mythtv DB
1303     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1304
1305   fi
1306
1307   fi
1308
1309   # remove the ddrescue DVD ISO image
1310   remove_intermediate_iso_file
1311
1312   # remove the tmp dvdbackup folder of the DVD image
1313   remove_intermediate_dvdbackup_folder
1314
1315   # eject the DVD disk upon completion
1316   [ $eject_disk -eq 1 ] && eject -T $dev
1317
1318   date=`date`
1319   echo "$date DVD rip completed" | tee -a "$logfile"
1320
1321   if [[ -n "$mailto" ]]; then
1322     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1323   fi
1324
1325 fi
1326
1327 ##############################################################################################